/*
 * Kangaroo Punch MultiPlayer Game Server Mark II
 * Copyright (C) 2020-2021  Scott Duensing
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */


#ifndef IMAGE_H
#define IMAGE_H


#include "os.h"
#include "color.h"

#include "thirdparty/stb_image.h"


typedef struct ImageS {
	uint16_t   width;
	uint16_t   height;
	ColorT   **pixels;
} ImageT;


ImageT   *imageAllocate(uint16_t w, uint16_t h);
ImageT   *imageCreate(uint16_t w, uint16_t h, ColorT color);
ImageT   *imageFromRAMLoad(uint8_t *buffer, size_t len);
uint16_t  imageHeightGet(ImageT *image);
uint8_t   imageInfoGet(char *filename, uint16_t *width, uint16_t *height);
ImageT   *imageLoad(char *filename);
ColorT    imagePixelGet(ImageT *image, uint16_t x, uint16_t y);
void      imageRender(ImageT *image, uint16_t x, uint16_t y);
void      imageRenderWithAlpha(ImageT *image, uint16_t x, uint16_t y, ColorT alpha);
void      imageUnload(ImageT **image);
uint16_t  imageWidthGet(ImageT *image);


#endif // IMAGE_H
